&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Procedure 
/*------------------------------------------------------------------------
    File        : mvctempcontrol.p
    Purpose     : Control object for the Progress 4GL MVC Demo

    Syntax      :

    Description :

    Author(s)   : Frank Beusenberg
    Created     :
    Notes       :
  ----------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

DEFINE VARIABLE hModel              AS HANDLE      NO-UNDO.
DEFINE VARIABLE hView               AS HANDLE      NO-UNDO.
DEFINE VARIABLE hCelsiusView        AS HANDLE      NO-UNDO.
DEFINE VARIABLE hFahrenheitView     AS HANDLE      NO-UNDO.
DEFINE VARIABLE hSliderView         AS HANDLE      NO-UNDO.
DEFINE VARIABLE hGaugeView          AS HANDLE      NO-UNDO.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Procedure
&Scoped-define DB-AWARE no



/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Procedure
   Allow: 
   Frames: 0
   Add Fields to: Neither
   Other Settings: CODE-ONLY
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW Procedure ASSIGN
         HEIGHT             = 10.05
         WIDTH              = 60.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

 


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Procedure 


/* ***************************  Main Block  *************************** */

ON "CLOSE" OF THIS-PROCEDURE
    RUN DestroyObject.

ASSIGN  hModel              = ?
        hView               = ?
        hCelsiusView        = ?
        hFahrenheitView     = ?
        hSliderView         = ?
        hGaugeView          = ?
        .

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&IF DEFINED(EXCLUDE-ButtonClick) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE ButtonClick Procedure 
PROCEDURE ButtonClick :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

    DEFINE INPUT  PARAMETER pcObjectName    AS CHARACTER   NO-UNDO.

    CASE pcObjectName:

        WHEN "ExitApp"      THEN APPLY "CLOSE" TO THIS-PROCEDURE.
        WHEN "btnCView"     THEN RUN LaunchCelsiusView.
        WHEN "btnFView"     THEN RUN LaunchFahrenheitView.
        WHEN "btnSlider"    THEN RUN LaunchSliderView.
        WHEN "btnGauge"     THEN RUN LaunchGaugeView.

    END CASE.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-DestroyObject) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE DestroyObject Procedure 
PROCEDURE DestroyObject :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

    IF VALID-HANDLE( hView )                THEN APPLY "CLOSE" TO hView.
    IF VALID-HANDLE( hCelsiusView )         THEN APPLY "CLOSE" TO hCelsiusView.
    IF VALID-HANDLE( hFahrenheitView )      THEN APPLY "CLOSE" TO hFahrenheitView.
    IF VALID-HANDLE( hSliderView )          THEN APPLY "CLOSE" TO hSliderView.
    IF VALID-HANDLE( hGaugeView )           THEN APPLY "CLOSE" TO hGaugeView.
    IF VALID-HANDLE( hModel )               THEN APPLY "CLOSE" TO hModel.

    DELETE PROCEDURE THIS-PROCEDURE.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-InitializeObject) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE InitializeObject Procedure 
PROCEDURE InitializeObject :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

    RUN mvctempmodel.p PERSISTENT SET hModel.
    RUN InitializeObject IN hModel.
    
    RUN mvctempview.w PERSISTENT SET hView.
    RUN InitializeObject IN hView.
    
    SUBSCRIBE TO "ButtonClick" IN hView.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-LaunchCelsiusView) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE LaunchCelsiusView Procedure 
PROCEDURE LaunchCelsiusView :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

    RUN wcview.w PERSISTENT SET hCelsiusView.
    RUN InitializeObject IN hCelsiusView ( INPUT hModel ).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-LaunchFahrenheitView) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE LaunchFahrenheitView Procedure 
PROCEDURE LaunchFahrenheitView :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

    RUN wfview.w PERSISTENT SET hFahrenheitView.
    RUN InitializeObject IN hFahrenheitView ( INPUT hModel ).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-LaunchGaugeView) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE LaunchGaugeView Procedure 
PROCEDURE LaunchGaugeView :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

    RUN wgaugeview.w PERSISTENT SET hGaugeView.
    RUN InitializeObject IN hGaugeView ( INPUT hModel ).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-LaunchSliderView) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE LaunchSliderView Procedure 
PROCEDURE LaunchSliderView :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

    RUN wsliderview.w PERSISTENT SET hSliderView.
    RUN InitializeObject IN hSliderView ( INPUT hModel ).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

